using SoapEndpoint.Service.Flows.Bewindvoering.v1.LogbookService;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;
using SoapEndpoint.Tester.Scenario.Flow.Bewindvoering;

namespace SoapEndpoint.Tester.Scenario.Implementations.Bewindvoering;

public class BijlageScenario : BewindvoeringScenarioBase
{
    public override string Name => "Bijlage scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Start bewind met bijlage");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_StartBewind, BerichtType.SE_AntwoordMeldingBewind, true));

        StartNewScenario("Start bewind zonder bijlage");

        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_StartBewind, null,
            ShvKnooppuntFoutcode.Bijlageverplichtvoorbericht);

        StartNewScenario("Actualisatie bewindgegevens met bijlage");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_ActualisatieBewindgegevens, BerichtType.SE_AntwoordMeldingBewind, true));

        StartNewScenario("Actualisatie bewindgegevens zonder bijlage");

        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_ActualisatieBewindgegevens, null,
            ShvKnooppuntFoutcode.Bijlageverplichtvoorbericht);

        StartNewScenario("Eind bewind met bijlage");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_EindeBewind, BerichtType.SE_AntwoordMeldingBewind, true));

        StartNewScenario("Eind bewind zonder bijlage");

        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_EindeBewind, null,
            ShvKnooppuntFoutcode.Bijlageverplichtvoorbericht);
    }
}