﻿using SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;

namespace SoapEndpoint.Tester.Scenario.Implementations.Inventarisatie;

public class SeSectorStandaardScenario : InventarisatieScenarioBase
{
    public override string Name => "Se Sector Standaard scenario";

    protected override async Task ExecuteAsync()
    {
        await SendInvalidSaldoverzoek();
    }

    private async Task SendInvalidSaldoverzoek()
    {
        var messageTypes = new List<BerichtType>
        {
            BerichtType.SHV_SaldoverzoekPubliek,
            BerichtType.SHV_SaldoverzoekNuts,
            BerichtType.SHV_SaldoverzoekZorg
        };

        foreach (var messageType in messageTypes)
        {
            StartNewScenario($"Foutsituatie: {messageType}");

            await Manager.SHV_SendIncorrectMessageAsync(Conversation, messageType, null,
                ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);
        }
    }
}