using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v1.ErrorMessage;
using SoapEndpoint.Service.Systeem.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.Schuldbemiddeling;

namespace SoapEndpoint.Tester.Scenario.Implementations.Schuldbemiddeling;

public class SeSectorPubliekScenario : SchuldbemiddelingScenarioBase
{
    public override string Name => "SE sector publiek scenario";

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["SeGovernmentTestOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Foutsituatie: klant gemeld voor SHV");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, Berichttype.SHV_KlantGemeldVoorShv, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);

        StartNewScenario("Foutsituatie: saldoverzoek");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, Berichttype.SHV_Saldoverzoek, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);

        StartNewScenario("Happy flow");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(Berichttype.SHV_KlantBsnGemeldVoorShv, Berichttype.SE_KlantGemeldVoorShvAntwoord),
            new ShvFlowItem(Berichttype.SHV_SaldoverzoekPubliek, Berichttype.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(Berichttype.SHV_Betaalvoorstel, Berichttype.SE_BetaalvoorstelAntwoord),
            new ShvFlowItem(Berichttype.SHV_SchuldregelingGeaccordeerd));
    }
}