﻿namespace SoapEndpoint.Tester.Scenario;

public class ScenarioResultGroup
{
    public ScenarioResultGroup(ScenarioBase scenario, IList<ScenarioResult> results = null)
    {
        Results = results ?? new List<ScenarioResult>();
        Scenario = scenario;
    }

    public IList<ScenarioResult> Results { get; }
    public ScenarioBase Scenario { get; }
    public bool Success => Results.All(r => r.Success);

    public ScenarioResult Result => Results.Any() ? Results[Results.Count - 1] : null;

    public void AddResult(ScenarioResult result)
    {
        Results.Add(result);
    }
}