﻿using SoapEndpoint.Service.Proxy.Models.Flows;

namespace SoapEndpoint.Service.Proxy.Models.Systeem;

public class AdresboekOrganisatieModel
{
    public Guid Referentienummer { get; set; }
    public string Naam { get; set; }
    public AdresModel Adres { get; set; }
    public ContactpersoonModel Contactpersoon { get; set; }
    public ShvSector? SectorSHV { get; set; }
    public SeSector? SectorSE { get; set; }
    public SeBerichtType? BerichtSE { get; set; }
    public bool? NvvkLid { get; set; }
    public string Applicatienaam { get; set; }
    public string KvkNummer { get; set; }
    public string Vestigingsnummer { get; set; }
    public bool CollectiefSchuldRegelen { get; set; }
    public bool? BijVoorbaatAkkoord { get; set; }
    public NvvkConvenant? NvvkConvenant { get; set; }
    public bool Geblokkeerd { get; set; }
    public RedenGeblokkeerd? RedenGeblokkeerd { get; set; }
    public bool? Vtlb { get; set; }
    public bool? Toestemmingsverklaring { get; set; }
    public OrganisatieType OrganisatieType { get; set; }
    public List<OrganizationFlowModel> OndersteundeFlows { get; } = new();

    public string Sector
    {
        get
        {
            switch (OrganisatieType)
            {
                case OrganisatieType.Schuldhulpverlener when SectorSHV.HasValue:
                    return SectorSHV.Value.ToString();
                case OrganisatieType.Schuldeiser when SectorSE.HasValue:
                    return SectorSE.Value.ToString();
                case OrganisatieType.Waarborgfonds:
                default:
                    return string.Empty;
            }
        }
    }
}