﻿using AutoMapper;
using SoapEndpoint.Service.Flows.Inventarisatie.v1.ShvService;
using SoapEndpoint.Service.Proxy.Models.Flows;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using BerichtType = SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService.BerichtType;

namespace SoapEndpoint.Service.Proxy.ServiceProxies.Flows.Inventarisatie.v1;

public class ShvProxy : IMessageProxy<BerichtType>
{
    private readonly IMapper _mapper;
    private readonly ISoapShvService _service;

    public ShvProxy(IMapper mapper, ISoapShvService service)
    {
        _mapper = mapper;
        _service = service;
    }

    public async Task<ShvKnooppuntBerichtBevestigingModel> SendMessageAsync(BerichtHeaderModel header,
        BerichtModel<BerichtType> bericht)
    {
        var request = new SendMessageRequest
        {
            bericht = _mapper.Map<ShvBericht>(bericht),
            Header = _mapper.Map<BerichtHeaderSHV>(header)
        };

        var response = await _service.SendMessageAsync(request);
        return _mapper.Map<ShvKnooppuntBerichtBevestigingModel>(response.SendMessageResult);
    }
}